From 09cea1fc46bc97785b3f46932b76c92f17020fdb Mon Sep 17 00:00:00 2001
From: Ajin Cherian <ajinc@fast.au.fujitsu.com>
Date: Wed, 7 Jun 2023 08:07:29 -0400
Subject: [PATCH 5/8] DDL replication for Table DDL commands

OVERVIEW
--------
To support DDL replication, we use the event trigger and DDL deparsing
facilities. During CREATE PUBLICATION we register a 'command end' trigger that
deparses the DDL (if the DDL is annotated as ddlreplok for DDL replication in
cmdtaglist.h) as a JSON blob, and WAL logs it. The event trigger is automatically
removed at the time of DROP PUBLICATION. The WALSender decodes the WAL and sends
it downstream similar to other DML commands. The subscriber then converts JSON
back to the DDL command string and executes it. In the subscriber, we also add
the newly added rel to pg_subscription_rel so that the DML changes on the new
table can be replicated without having to manually run
"ALTER SUBSCRIPTION ... REFRESH PUBLICATION".

For non-rewrite ALTER object command and CREATE object command:
---------------------------------------------------------------
We deparse the command at ddl_command_end event trigger and WAL log the
deparsed JSON string. The WALSender decodes the WAL and sends it to
subscriber if the created/altered table is published.

For DROP object:
----------------
The 'command start' event handler logs a ddl message with the relids of
the tables that are dropped which the output plugin (pgoutput) stores in
its internal data structure after verifying that it is for a table that is
part of the publication. Later the 'command end' event handler sends the
actual drop message. On receiving the 'command end', pgoutput sends the
DROP command only if it is for one of the relids marked for deletion.

The reason we have to do this is because, once the logical decoder
receives the 'command end' message,  the relid of the table is no longer
valid as it has been deleted as part of invalidations received for the
drop table command. It is no longer possible to verify if the table is
part of the publication list or not. To make this possible, two more elements
are added to the ddl xlog and ddl message, (relid and cmdtype).

We could have also handled all this on the subscriber side, but
that would mean sending spurious ddl messages for tables that are not part
of the publication.

For table_rewrite ALTER TABLE command:
--------------------------------------
Executing a non-immutable expression during the table rewrite phase is not
allowed, as it may result in different data between publisher and subscriber.
While some may suggest converting the rewrite inserts to updates and replicate
them afte the ddl command to maintain data consistency. But it doesn't work if
the replica identity column is altered in the command. This is because the
rewrite inserts do not contain the old values and therefore cannot be converted
to update.

LIMIT:
Commands contain volatile functions are not allowed. Because
it's possible the functions contain DDL/DML in which case these operations
will be executed twice and cause duplicate data. In addition, we don't know
whether the tables being accessed by these DDL/DML are published or not. So
blindly allowing such functions can allow unintended clauses like the tables
accessed in those functions may not even exist on the subscriber.
---
 contrib/test_decoding/expected/ddl.out        |  27 ++
 contrib/test_decoding/sql/ddl.sql             |   6 +
 contrib/test_decoding/test_decoding.c         |  48 ++
 doc/src/sgml/catalogs.sgml                    |   9 +
 doc/src/sgml/logical-replication.sgml         |  75 ++++
 src/backend/access/rmgrdesc/Makefile          |   1 +
 .../access/rmgrdesc/logicalddlmsgdesc.c       |  52 +++
 src/backend/access/rmgrdesc/meson.build       |   1 +
 src/backend/access/transam/rmgr.c             |   1 +
 src/backend/catalog/pg_publication.c          |   1 +
 src/backend/commands/alter.c                  |  17 +
 src/backend/commands/ddldeparse.c             | 101 ++++-
 src/backend/commands/event_trigger.c          |  60 ++-
 src/backend/commands/publicationcmds.c        | 237 +++++++++-
 src/backend/replication/logical/Makefile      |   2 +
 src/backend/replication/logical/ddlmessage.c  |  83 ++++
 src/backend/replication/logical/ddltrigger.c  | 355 +++++++++++++++
 src/backend/replication/logical/decode.c      |  41 ++
 src/backend/replication/logical/logical.c     |  97 +++-
 .../replication/logical/logicalfuncs.c        |  24 +
 src/backend/replication/logical/meson.build   |   2 +
 src/backend/replication/logical/proto.c       |  43 ++
 .../replication/logical/reorderbuffer.c       | 135 ++++++
 src/backend/replication/logical/worker.c      | 232 ++++++++++
 src/backend/replication/pgoutput/pgoutput.c   | 251 ++++++++---
 src/backend/tcop/cmdtag.c                     |  26 +-
 src/backend/tcop/utility.c                    |   2 +-
 src/backend/utils/cache/relcache.c            |   1 +
 src/bin/pg_dump/pg_dump.c                     |  26 +-
 src/bin/pg_dump/pg_dump.h                     |   1 +
 src/bin/pg_dump/t/002_pg_dump.pl              |   2 +-
 src/bin/pg_waldump/.gitignore                 |   1 +
 src/bin/pg_waldump/rmgrdesc.c                 |   1 +
 src/bin/psql/describe.c                       |  21 +-
 src/include/access/rmgrlist.h                 |   1 +
 src/include/catalog/pg_event_trigger.h        |   1 +
 src/include/catalog/pg_proc.dat               |  20 +
 src/include/catalog/pg_publication.h          |  30 +-
 src/include/commands/event_trigger.h          |   9 +-
 src/include/commands/publicationcmds.h        |  14 +
 src/include/replication/ddlmessage.h          |  60 +++
 src/include/replication/decode.h              |   1 +
 src/include/replication/logicalproto.h        |   4 +
 src/include/replication/output_plugin.h       |  27 ++
 src/include/replication/pgoutput.h            |   1 +
 src/include/replication/reorderbuffer.h       |  39 ++
 src/include/tcop/cmdtag.h                     |   4 +-
 src/include/tcop/cmdtaglist.h                 | 386 ++++++++--------
 src/include/tcop/ddldeparse.h                 |  13 +-
 src/include/utils/rel.h                       |   2 +
 src/test/regress/expected/psql.out            |   6 +-
 src/test/regress/expected/publication.out     | 420 +++++++++---------
 src/tools/pgindent/typedefs.list              |   6 +
 53 files changed, 2498 insertions(+), 528 deletions(-)
 create mode 100644 src/backend/access/rmgrdesc/logicalddlmsgdesc.c
 create mode 100644 src/backend/replication/logical/ddlmessage.c
 create mode 100644 src/backend/replication/logical/ddltrigger.c
 create mode 100644 src/include/replication/ddlmessage.h

diff --git a/contrib/test_decoding/test_decoding.c b/contrib/test_decoding/test_decoding.c
index 12d1d0505d..9286f97258 100644
--- a/contrib/test_decoding/test_decoding.c
+++ b/contrib/test_decoding/test_decoding.c
@@ -14,9 +14,11 @@
 
 #include "catalog/pg_type.h"
 
+#include "replication/ddlmessage.h"
 #include "replication/logical.h"
 #include "replication/origin.h"
 
+#include "tcop/ddldeparse.h"
 #include "utils/builtins.h"
 #include "utils/lsyscache.h"
 #include "utils/memutils.h"
@@ -72,6 +74,12 @@ static void pg_decode_message(LogicalDecodingContext *ctx,
 							  ReorderBufferTXN *txn, XLogRecPtr lsn,
 							  bool transactional, const char *prefix,
 							  Size sz, const char *message);
+static void pg_decode_ddl_message(LogicalDecodingContext *ctx,
+								  ReorderBufferTXN *txn,
+								  XLogRecPtr message_lsn,
+								  const char *prefix, Oid relid,
+								  DeparsedCommandType cmdtype,
+								  Size sz, const char *message);
 static bool pg_decode_filter_prepare(LogicalDecodingContext *ctx,
 									 TransactionId xid,
 									 const char *gid);
@@ -135,6 +143,7 @@ _PG_output_plugin_init(OutputPluginCallbacks *cb)
 	cb->filter_by_origin_cb = pg_decode_filter;
 	cb->shutdown_cb = pg_decode_shutdown;
 	cb->message_cb = pg_decode_message;
+	cb->ddl_cb = pg_decode_ddl_message;
 	cb->filter_prepare_cb = pg_decode_filter_prepare;
 	cb->begin_prepare_cb = pg_decode_begin_prepare_txn;
 	cb->prepare_cb = pg_decode_prepare_txn;
@@ -750,6 +759,45 @@ pg_decode_message(LogicalDecodingContext *ctx,
 	OutputPluginWrite(ctx, true);
 }
 
+static void
+pg_decode_ddl_message(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
+					  XLogRecPtr message_lsn, const char *prefix, Oid relid,
+					  DeparsedCommandType cmdtype, Size sz, const char *message)
+{
+	OutputPluginPrepareWrite(ctx, true);
+	appendStringInfo(ctx->out, "DDL message: prefix: %s, relid: %u, ",
+					 prefix, relid);
+
+	switch(cmdtype)
+	{
+	case DCT_SimpleCmd:
+		appendStringInfo(ctx->out, "cmdtype: Simple, ");
+		break;
+	case DCT_TableDropStart:
+		appendStringInfo(ctx->out, "cmdtype: Drop start, ");
+		break;
+	case DCT_TableDropEnd:
+		appendStringInfo(ctx->out, "cmdtype: Drop end, ");
+		break;
+	case DCT_TableAlter:
+		appendStringInfo(ctx->out, "cmdtype: Alter table, ");
+		break;
+	case DCT_ObjectCreate:
+		appendStringInfo(ctx->out, "cmdtype: Create, ");
+		break;
+	case DCT_ObjectDrop:
+		appendStringInfo(ctx->out, "cmdtype: Drop, ");
+		break;
+	default:
+		appendStringInfo(ctx->out, "cmdtype: Invalid, ");
+		break;
+	}
+
+	appendStringInfo(ctx->out, "sz: %zu content: ", sz);
+	appendBinaryStringInfo(ctx->out, message, sz);
+	OutputPluginWrite(ctx, true);
+}
+
 static void
 pg_decode_stream_start(LogicalDecodingContext *ctx,
 					   ReorderBufferTXN *txn)
diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index ed32ca0349..3568d070ab 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -3863,6 +3863,15 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
       </para></entry>
      </row>
 
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>evtisinternal</structfield> <type>bool</type>
+      </para>
+      <para>
+       True if the event trigger is internally generated.
+      </para></entry>
+     </row>
+
      <row>
       <entry role="catalog_table_entry"><para role="column_definition">
        <structfield>evttags</structfield> <type>text[]</type>
diff --git a/doc/src/sgml/logical-replication.sgml b/doc/src/sgml/logical-replication.sgml
index 59cf92e6a9..e9286e9012 100644
--- a/doc/src/sgml/logical-replication.sgml
+++ b/doc/src/sgml/logical-replication.sgml
@@ -1457,6 +1457,81 @@ test_sub=# SELECT * FROM t1 ORDER BY id;
 
  </sect1>
 
+ <sect1 id="logical-replication-ddl">
+  <title>DDL Replication</title>
+  <para>
+    Data Definition Language (DDL) commands can be replicated using logical replication.
+    When enabled this feature automatically replicates supported DDL commands
+    that are successfully executed on a publisher to a subscriber. This is
+    especially useful if you have many schema changes over time that need replication.
+  </para>
+
+  <para>
+    For example, a CREATE TABLE command executed on the publisher gets
+    WAL-logged, and forwarded to the subscriber to replay; then an implicit "ALTER
+    SUBSCRIPTION ... REFRESH PUBLICATION" is performed on the subscriber database so any
+    following DML changes on the new table can be replicated.
+  </para>
+
+  <para>
+    DDL replication is disabled by default, it can be enabled using the ddl PUBLICATION
+    option. This option currently has one level and is only allowed to be set if the
+    PUBLICATION is FOR ALL TABLES or FOR TABLES IN SCHEMA.
+  </para>
+
+  <itemizedlist>
+    <listitem>
+      <para>
+        table: this option enables replication of Table DDL commands,
+        which include:
+        <itemizedlist>
+          <listitem>
+            <para>
+              CREATE/ALTER/DROP TABLE
+            </para>
+          </listitem>
+
+          <listitem>
+            <para>
+              CREATE TABLE AS
+            </para>
+          </listitem>
+
+        </itemizedlist>
+      </para>
+    </listitem>
+  </itemizedlist>
+
+  <sect2 id="ddl-replication-option-examples">
+    <title>Examples - Setup DDL Replication on the Publisher</title>
+
+    <para>
+      Enable TABLE DDL replication for an existing PUBLICATION:
+<programlisting>
+ALTER PUBLICATION mypub SET (ddl = 'table');
+</programlisting></para>
+
+  </sect2>
+
+  <sect2 id="ddl-replication-supported-commands">
+    <title>Supported DDL commands</title>
+
+    <para>
+      The DDL commands supported for logical replication are Table DDL commands,
+      include <literal>ALTER TABLE</literal>, <literal>CREATE TABLE</literal>,
+      <literal>CREATE TABLE AS</literal>, and <literal>DROP TABLE</literal>.
+      Other object commands and global commands are currently not
+      supported for replication. Global commands can be executed at any
+      database, include ROLE statements, Database statements, TableSpace
+      statements and some of the GrantStmt/RevokeStmt if the target object is a
+      global object. Temporary and unlogged table will not be replicated. User
+      should take care when creating these objects as these objects might be
+      required by the objects that are replicated (for example creation of
+      tables that might refer to an user-created tablespace will fail in the
+      subscriber if the user created tablespaces do not exist on the
+      subscriber).
+    </para>
+
  <sect1 id="logical-replication-conflicts">
   <title>Conflicts</title>
 
diff --git a/src/backend/access/rmgrdesc/Makefile b/src/backend/access/rmgrdesc/Makefile
index cd95eec37f..fd67f044e4 100644
--- a/src/backend/access/rmgrdesc/Makefile
+++ b/src/backend/access/rmgrdesc/Makefile
@@ -18,6 +18,7 @@ OBJS = \
 	gistdesc.o \
 	hashdesc.o \
 	heapdesc.o \
+	logicalddlmsgdesc.o \
 	logicalmsgdesc.o \
 	mxactdesc.o \
 	nbtdesc.o \
diff --git a/src/backend/access/rmgrdesc/logicalddlmsgdesc.c b/src/backend/access/rmgrdesc/logicalddlmsgdesc.c
new file mode 100644
index 0000000000..5f58e0fe51
--- /dev/null
+++ b/src/backend/access/rmgrdesc/logicalddlmsgdesc.c
@@ -0,0 +1,52 @@
+/*-------------------------------------------------------------------------
+ *
+ * logicalddlmsgdesc.c
+ *	  rmgr descriptor routines for replication/logical/ddlmessage.c
+ *
+ * Portions Copyright (c) 2015-2023, PostgreSQL Global Development Group
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/rmgrdesc/logicalddlmsgdesc.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "replication/ddlmessage.h"
+
+void
+logicalddlmsg_desc(StringInfo buf, XLogReaderState *record)
+{
+	char	   *rec = XLogRecGetData(record);
+	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
+
+	if (info == XLOG_LOGICAL_DDL_MESSAGE)
+	{
+		xl_logical_ddl_message *xlrec = (xl_logical_ddl_message *) rec;
+		char	   *prefix = xlrec->message;
+		char	   *message = xlrec->message + xlrec->prefix_size;
+		char	   *sep = "";
+
+		Assert(prefix[xlrec->prefix_size - 1] == '\0');
+
+		appendStringInfo(buf, "prefix \"%s\"; payload (%zu bytes): ",
+						 prefix, xlrec->message_size);
+		appendStringInfo(buf, "relid %u cmdtype %u", xlrec->relid, xlrec->cmdtype);
+		/* Write message payload as a series of hex bytes */
+		for (int cnt = 0; cnt < xlrec->message_size; cnt++)
+		{
+			appendStringInfo(buf, "%s%02X", sep, (unsigned char) message[cnt]);
+			sep = " ";
+		}
+	}
+}
+
+const char *
+logicalddlmsg_identify(uint8 info)
+{
+	if ((info & ~XLR_INFO_MASK) == XLOG_LOGICAL_DDL_MESSAGE)
+		return "DDL";
+
+	return NULL;
+}
diff --git a/src/backend/access/rmgrdesc/meson.build b/src/backend/access/rmgrdesc/meson.build
index f76e87e2d7..614fd7c1ac 100644
--- a/src/backend/access/rmgrdesc/meson.build
+++ b/src/backend/access/rmgrdesc/meson.build
@@ -11,6 +11,7 @@ rmgr_desc_sources = files(
   'gistdesc.c',
   'hashdesc.c',
   'heapdesc.c',
+  'logicalddlmsgdesc.c',
   'logicalmsgdesc.c',
   'mxactdesc.c',
   'nbtdesc.c',
diff --git a/src/backend/access/transam/rmgr.c b/src/backend/access/transam/rmgr.c
index 7d67eda5f7..678e81ae01 100644
--- a/src/backend/access/transam/rmgr.c
+++ b/src/backend/access/transam/rmgr.c
@@ -27,6 +27,7 @@
 #include "fmgr.h"
 #include "funcapi.h"
 #include "miscadmin.h"
+#include "replication/ddlmessage.h"
 #include "replication/decode.h"
 #include "replication/message.h"
 #include "replication/origin.h"
diff --git a/src/backend/catalog/pg_publication.c b/src/backend/catalog/pg_publication.c
index c488b6370b..d8a5940141 100644
--- a/src/backend/catalog/pg_publication.c
+++ b/src/backend/catalog/pg_publication.c
@@ -1028,6 +1028,7 @@ GetPublication(Oid pubid)
 	pub->pubactions.pubupdate = pubform->pubupdate;
 	pub->pubactions.pubdelete = pubform->pubdelete;
 	pub->pubactions.pubtruncate = pubform->pubtruncate;
+	pub->pubactions.pubddl_table = pubform->pubddl_table;
 	pub->pubviaroot = pubform->pubviaroot;
 
 	ReleaseSysCache(tup);
diff --git a/src/backend/commands/alter.c b/src/backend/commands/alter.c
index e95dc31bde..23435c9915 100644
--- a/src/backend/commands/alter.c
+++ b/src/backend/commands/alter.c
@@ -308,6 +308,23 @@ AlterObjectRename_internal(Relation rel, Oid objectId, const char *new_name)
 		/* Wake up related replication workers to handle this change quickly */
 		LogicalRepWorkersWakeupAtCommit(objectId);
 	}
+	else if (classId == EventTriggerRelationId)
+	{
+		Form_pg_event_trigger evtForm = (Form_pg_event_trigger) GETSTRUCT(oldtup);
+
+		if (SearchSysCacheExists1(EVENTTRIGGERNAME, CStringGetDatum(new_name)))
+			report_name_conflict(classId, new_name);
+
+		/*
+		 * Event triggers created internally are not allowed to be altered by
+		 * user.
+		 */
+		if (evtForm->evtisinternal)
+			ereport(ERROR,
+					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+					 errmsg("permission denied: \"%s\" is a system event trigger",
+							NameStr(evtForm->evtname))));
+	}
 	else if (nameCacheId >= 0)
 	{
 		if (OidIsValid(namespaceId))
diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 6799c7fdaf..4eab5ea0c0 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -135,10 +135,10 @@ static ObjElem *new_object_object(ObjTree *value);
 static ObjTree *new_objtree_VA(char *fmt, int numobjs, ...);
 static JsonbValue *objtree_to_jsonb_rec(ObjTree *tree, JsonbParseState *state);
 static char *RelationGetColumnDefault(Relation rel, AttrNumber attno,
-									  List *dpcontext);
+									  List *dpcontext, Node **expr);
 
 static ObjTree *deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
-								  ColumnDef *coldef, bool is_alter);
+								  ColumnDef *coldef, bool is_alter, Node **expr);
 static ObjTree *deparse_ColumnIdentity(Oid seqrelid, char identity, bool alter_table);
 static ObjTree *deparse_ColumnSetOptions(AlterTableCmd *subcmd);
 
@@ -158,6 +158,27 @@ static inline ObjElem *deparse_Seq_As(Form_pg_sequence seqdata);
 static List *deparse_InhRelations(Oid objectId);
 static List *deparse_TableElements(Relation relation, List *tableElements, List *dpcontext,
 								   bool typed, bool composite);
+static void mark_function_volatile(ddl_deparse_context *context, Node *expr);
+
+/*
+ * Mark the max_volatility flag for an expression in the command.
+ */
+static void
+mark_function_volatile(ddl_deparse_context *context, Node *expr)
+{
+	if (context->max_volatility == PROVOLATILE_VOLATILE)
+		return;
+
+	if (contain_volatile_functions(expr))
+	{
+		context->max_volatility = PROVOLATILE_VOLATILE;
+		return;
+	}
+
+	if (context->max_volatility == PROVOLATILE_IMMUTABLE &&
+		contain_mutable_functions(expr))
+		context->max_volatility = PROVOLATILE_STABLE;
+}
 
 /*
  * Append present as false to a tree.
@@ -850,7 +871,8 @@ obtainConstraints(List *elements, Oid relationId)
  * passed attribute has a default value.
  */
 static char *
-RelationGetColumnDefault(Relation rel, AttrNumber attno, List *dpcontext)
+RelationGetColumnDefault(Relation rel, AttrNumber attno, List *dpcontext,
+						 Node **expr)
 {
 	Node	   *defval;
 	char	   *defstr;
@@ -860,6 +882,10 @@ RelationGetColumnDefault(Relation rel, AttrNumber attno, List *dpcontext)
 
 	defstr = deparse_expression(defval, dpcontext, false, false);
 
+	/* Collect the expression for later replication safety checks */
+	if (expr)
+		*expr = defval;
+
 	return defstr;
 }
 
@@ -903,7 +929,7 @@ RelationGetPartitionBound(Oid relid)
  */
 static ObjTree *
 deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
-				  ColumnDef *coldef, bool is_alter)
+				  ColumnDef *coldef, bool is_alter, Node **expr)
 {
 	ObjTree    *ret;
 	ObjTree    *tmp_obj;
@@ -1006,7 +1032,7 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 			char	   *defstr;
 
 			defstr = RelationGetColumnDefault(relation, attrForm->attnum,
-											  dpcontext);
+											  dpcontext, expr);
 
 			append_string_object(tmp_obj, "%{default}s", "default", defstr);
 		}
@@ -1047,7 +1073,7 @@ deparse_ColumnDef(Relation relation, List *dpcontext, bool composite,
 			char	   *defstr;
 
 			defstr = RelationGetColumnDefault(relation, attrForm->attnum,
-											  dpcontext);
+											  dpcontext, expr);
 			append_string_object(tmp_obj, "(%{generation_expr}s) STORED",
 								 "generation_expr", defstr);
 		}
@@ -1125,7 +1151,7 @@ deparse_ColumnDef_typed(Relation relation, List *dpcontext, ColumnDef *coldef)
 		char	   *defstr;
 
 		defstr = RelationGetColumnDefault(relation, attrForm->attnum,
-										  dpcontext);
+										  dpcontext, NULL);
 
 		append_string_object(tmp_obj, "%{default}s", "default", defstr);
 	}
@@ -1669,7 +1695,7 @@ deparse_TableElements(Relation relation, List *tableElements, List *dpcontext,
 												(ColumnDef *) elt) :
 						deparse_ColumnDef(relation, dpcontext,
 										  composite, (ColumnDef *) elt,
-										  false);
+										  false, NULL);
 					if (tree != NULL)
 						elements = lappend(elements, new_object_object(tree));
 				}
@@ -1970,7 +1996,7 @@ deparse_CreateTableAsStmt(CollectedCommand *cmd)
  * ALTER %{objtype}s %{only}s %{identity}D %{subcmds:, }s
  */
 static ObjTree *
-deparse_AlterRelation(CollectedCommand *cmd)
+deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 {
 	ObjTree    *ret;
 	ObjTree    *tmp_obj;
@@ -1980,6 +2006,7 @@ deparse_AlterRelation(CollectedCommand *cmd)
 	List	   *subcmds = NIL;
 	ListCell   *cell;
 	const char *reltype;
+	Node	   *expr = NULL;
 	Oid			relId = cmd->d.alterTable.objectId;
 	AlterTableStmt *stmt = NULL;
 
@@ -2052,7 +2079,10 @@ deparse_AlterRelation(CollectedCommand *cmd)
 				/* XXX need to set the "recurse" bit somewhere? */
 				Assert(IsA(subcmd->def, ColumnDef));
 				tree = deparse_ColumnDef(rel, dpcontext, false,
-										 (ColumnDef *) subcmd->def, true);
+										 (ColumnDef *) subcmd->def, true, &expr);
+
+				mark_function_volatile(context, expr);
+
 				tmp_obj = new_objtree_VA("ADD %{objtype}s %{if_not_exists}s %{definition}s", 4,
 										"objtype", ObjTypeString, "COLUMN",
 										"type", ObjTypeString, "add column",
@@ -2162,7 +2192,8 @@ deparse_AlterRelation(CollectedCommand *cmd)
 					attno = ((Form_pg_attribute) GETSTRUCT(attrtup))->attnum;
 					append_string_object(tmp_obj, "%{definition}s", "definition",
 										 RelationGetColumnDefault(rel, attno,
-																  dpcontext_rel));
+																  dpcontext_rel,
+																  NULL));
 					ReleaseSysCache(attrtup);
 				}
 
@@ -2297,12 +2328,40 @@ deparse_AlterRelation(CollectedCommand *cmd)
 				{
 					/* XXX need to set the "recurse" bit somewhere? */
 					Oid			constrOid = sub->address.objectId;
+					bool		isnull;
+					HeapTuple	tup;
+					Datum		val;
+					Constraint *constr;
 
 					/* Skip adding constraint for inherits table sub command */
 					if (!constrOid)
 						continue;
 
 					Assert(IsA(subcmd->def, Constraint));
+					constr = castNode(Constraint, subcmd->def);
+
+					if (!constr->skip_validation)
+					{
+						tup = SearchSysCache1(CONSTROID, ObjectIdGetDatum(constrOid));
+
+						if (HeapTupleIsValid(tup))
+						{
+							char	   *conbin;
+
+							/* Fetch constraint expression in parsetree form */
+							val = SysCacheGetAttr(CONSTROID, tup,
+												  Anum_pg_constraint_conbin, &isnull);
+
+							if (!isnull)
+							{
+								conbin = TextDatumGetCString(val);
+								expr = stringToNode(conbin);
+								mark_function_volatile(context, expr);
+							}
+
+							ReleaseSysCache(tup);
+						}
+					}
 
 					tmp_obj = new_objtree_VA("ADD CONSTRAINT %{name}I %{definition}s", 3,
 											"type", ObjTypeString, "add constraint",
@@ -2392,8 +2451,11 @@ deparse_AlterRelation(CollectedCommand *cmd)
 					 */
 					tmp_obj2 = new_objtree("USING");
 					if (def->raw_default)
+					{
 						append_string_object(tmp_obj2, "%{expression}s",
 											 "expression", sub->usingexpr);
+						mark_function_volatile(context, def->cooked_default);
+					}
 					else
 						append_not_present(tmp_obj2, "%{expression}s");
 
@@ -3113,7 +3175,7 @@ deparse_simple_command(CollectedCommand *cmd)
  * Workhorse to deparse a CollectedCommand.
  */
 char *
-deparse_utility_command(CollectedCommand *cmd, bool verbose_mode)
+deparse_utility_command(CollectedCommand *cmd, ddl_deparse_context *context)
 {
 	OverrideSearchPath *overridePath;
 	MemoryContext oldcxt;
@@ -3149,7 +3211,7 @@ deparse_utility_command(CollectedCommand *cmd, bool verbose_mode)
 	overridePath->addTemp = true;
 	PushOverrideSearchPath(overridePath);
 
-	verbose = verbose_mode;
+	verbose = context->verbose_mode;
 
 	switch (cmd->type)
 	{
@@ -3157,7 +3219,7 @@ deparse_utility_command(CollectedCommand *cmd, bool verbose_mode)
 			tree = deparse_simple_command(cmd);
 			break;
 		case SCT_AlterTable:
-			tree = deparse_AlterRelation(cmd);
+			tree = deparse_AlterRelation(cmd, context);
 			break;
 		case SCT_CreateTableAs:
 			tree = deparse_CreateTableAsStmt(cmd);
@@ -3197,8 +3259,17 @@ ddl_deparse_to_json(PG_FUNCTION_ARGS)
 {
 	CollectedCommand *cmd = (CollectedCommand *) PG_GETARG_POINTER(0);
 	char	   *command;
+	ddl_deparse_context context;
+
+	context.verbose_mode = true;
+
+	/*
+	 * Initialize the max_volatility flag to PROVOLATILE_IMMUTABLE, which is
+	 * the minimum volatility level.
+	 */
+	context.max_volatility = PROVOLATILE_IMMUTABLE;
 
-	command = deparse_utility_command(cmd, true);
+	command = deparse_utility_command(cmd, &context);
 
 	if (command)
 		PG_RETURN_TEXT_P(cstring_to_text(command));
